//
//  920MHz LoRa/FSK RF module ES920LR2/3 
//  configration
//

#include <M5Stack.h>
#include "LoRaConfig.h"

int reset_pin = 13; // DIPSW 8 ON  GPIO13 for RF module NRST


void LoRa_Reset(){
  pinMode(reset_pin, OUTPUT); // NRST "L"
  digitalWrite(reset_pin, LOW);
  delay(10);
  pinMode(reset_pin, INPUT);  // NRST open
  delay(1);
}


void modeDisplay(uint8_t LoRaMode){
  M5.Lcd.setTextSize(1);
  if (LoRaMode == 1){
    M5.Lcd.fillRect(30, 80, 260, 66, RED);
    M5.Lcd.setTextColor(BLACK, RED);
    M5.Lcd.drawCentreString("configration mode", 160, 100, 4);
  } else if (LoRaMode == 2){
    M5.Lcd.fillRect(30, 80, 260, 66, GREEN);
    M5.Lcd.setTextColor(BLACK, GREEN);
    M5.Lcd.drawCentreString("operation mode"   , 160, 100, 4);
  }
}


void resetDisplay(){
  String rx;
  LoRa_Reset();
  rx = Serial2.readString();
  modeDisplay((rx.indexOf("Select Mode [") >= 0)? CONFIG: OPE);
  Serial.print(rx);
}


int command(String s){
  String rx;
  if (s.compareTo("z") == 0){
    modeDisplay(OPE);
  }
  Serial2.print(s);
  Serial2.print("\r\n");
  Serial2.flush();
  Serial.println(s);
  Serial.flush();
  rx = Serial2.readString();
  Serial.print(rx);
  return (rx.indexOf("OK"));
}

int configMode(){
  int result = 0;
  String rx;
  while(1){
    command("config");
    delay(100); 
    LoRa_Reset();
    rx = Serial2.readString();
    Serial.print(rx);
    if (rx.indexOf("Select Mode [") >= 0) {
      modeDisplay(CONFIG);
      break;
    }
  }
  return (result);
}



int LoRaConfig(){
  if (command("2"     ) < 0) return(-1); // processor mode
  if (command("c 12"  ) < 0) return(-1); // spread factor
  if (command("d 2"   ) < 0) return(-1); // channel
  if (command("e 1234") < 0) return(-1); // PanID
  if (command("q 2"   ) < 0) return(-1); // operation mode
  if (command("w"     ) < 0) return(-1); // save
  command("z");                          // start
  return(0);
}
