//
//  920MHz LoRa/FSK RF module ES920LR2/3 
//  configration
//
//  MaiaR Create 2022/01/11
//  2022/03/05

#include <M5Stack.h>
#include "LoRaConfig.h"


int boot_pin  = 22; // DIP SW 7 ON  GPIO22 for ES920LR2/3 Boot0

void setup() {
  M5.begin();
  pinMode(boot_pin, OUTPUT);
  digitalWrite(boot_pin, LOW); // boot0 L : not boot mode

  M5.Lcd.setTextColor(WHITE);
  Serial2.setTimeout(50);

  Serial2.begin(115200);                     // RX:16  TX:17  DIPSW 1,2
//  Serial2.begin(115200, SERIAL_8N1, 19, 26); // RX:19  TX:26  DIPSW 3,4
//  Serial2.begin(115200, SERIAL_8N1,  2,  5); // RX:2   TX:5   DIPSW 5,6
  
  M5.Lcd.fillScreen(BLACK);
  M5.Lcd.drawCentreString("ES920LR2/3",  160, 20, 4);

  M5.Lcd.setTextSize(2);
  M5.Lcd.drawCentreString("PRESET",  65, 220, 1);
  M5.Lcd.drawCentreString("CONFIG", 160, 220, 1);
  M5.Lcd.drawCentreString("RESET" , 255, 220, 1);
}



void loop(){
  static uint8_t opflag = 0;
  String txs;
  String rxs;
  
  M5.update();
  if (M5.BtnA.wasPressed()){
    configMode();
    LoRaConfig();
  }
  if (M5.BtnB.wasPressed()){
    configMode();
  }
  if (M5.BtnC.wasPressed()){
    resetDisplay();
  }

  if (Serial.available() > 0) {
    txs = Serial.readString();
    Serial2.print(txs);
    Serial.print(txs);
    opflag = txs.equals("z\r\n")? 1: 0;
  }
  if (Serial2.available() > 0) {
    rxs = Serial2.readString();
    Serial.print(rxs);
    if (opflag == 1 && rxs.indexOf("OK") >= 0){
      modeDisplay(OPE);
      opflag = 0;
    }
  }
}
